DevExtreme v23.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.
Data Grid

Row Template

Row templates allow you to display custom content in data rows. In this demo, a dataRowTemplate adds employee images and extra information to regular data rows.

You should disable or implement certain DataGrid features manually to use row templates. Refer to the dataRowTemplate article for details.

Backend API
Copy to CodePen
Apply
Reset
$(() => { const formatDate = new Intl.DateTimeFormat('en-US').format; $('#gridContainer').dxDataGrid({ dataSource: employees, keyExpr: 'ID', dataRowTemplate(container, item) { const { data } = item; const markup = '<tr class=\'main-row\'>' + `<td rowspan='2'><img src='${data.Picture}' /></td>` + `<td>${data.Prefix}</td>` + `<td>${data.FirstName}</td>` + `<td>${data.LastName}</td>` + `<td>${data.Position}</td>` + `<td>${formatDate(new Date(data.BirthDate))}</td>` + `<td>${formatDate(new Date(data.HireDate))}</td>` + '</tr>' + '<tr class=\'notes-row\'>' + `<td colspan='6'><div>${data.Notes}</div></td>` + '</tr>'; container.append(markup); }, rowAlternationEnabled: true, hoverStateEnabled: true, columnAutoWidth: true, showBorders: true, columns: [{ caption: 'Photo', width: 100, allowFiltering: false, allowSorting: false, }, { dataField: 'Prefix', caption: 'Title', width: 70, }, 'FirstName', 'LastName', 'Position', { dataField: 'BirthDate', dataType: 'date', }, { dataField: 'HireDate', dataType: 'date', }, ], }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <script src="https://cdnjs.cloudflare.com/ajax/libs/cldrjs/0.4.4/cldr.min.js"></script> <script src="https://cdnjs.cloudflare.com/ajax/libs/cldrjs/0.4.4/cldr/event.min.js"></script> <script src="https://cdnjs.cloudflare.com/ajax/libs/cldrjs/0.4.4/cldr/supplemental.min.js"></script> <script src="https://cdnjs.cloudflare.com/ajax/libs/cldrjs/0.4.4/cldr/unresolved.min.js"></script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" /> <script src="https://cdn3.devexpress.com/jslib/23.1.5/js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gridContainer"></div> </div> </body> </html>
#gridContainer { height: 450px; } .dx-row img { height: 100px; } #gridContainer tr.main-row td:not(:first-child) { height: 21px; } #gridContainer tr.notes-row { white-space: normal; vertical-align: top; } #gridContainer tr.notes-row td { height: 70px; color: #999; } .dark #gridContainer tr.notes-row td { color: #777; } #gridContainer tbody.dx-state-hover { background-color: #ebebeb; } .dark #gridContainer tbody.dx-state-hover { background-color: #484848; } #gridContainer tbody.dx-state-hover tr.main-row td { color: #000; } .dark #gridContainer tbody.dx-state-hover tr.main-row td { color: #ccc; } #gridContainer tbody.dx-state-hover tr.notes-row td { color: #888; }
const employees = [{ ID: 1, FirstName: 'John', LastName: 'Heart', Prefix: 'Mr.', Position: 'CEO', Picture: '../../../../images/employees/01.png', BirthDate: '1964/03/16', HireDate: '1995/01/15', Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.', Address: '351 S Hill St.', }, { ID: 2, FirstName: 'Olivia', LastName: 'Peyton', Prefix: 'Mrs.', Position: 'Sales Assistant', Picture: '../../../../images/employees/09.png', BirthDate: '1981/06/03', HireDate: '2012/05/14', Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.', Address: '807 W Paseo Del Mar', }, { ID: 3, FirstName: 'Robert', LastName: 'Reagan', Prefix: 'Mr.', Position: 'CMO', Picture: '../../../../images/employees/03.png', BirthDate: '1974/09/07', HireDate: '2002/11/08', Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.', Address: '4 Westmoreland Pl.', }, { ID: 4, FirstName: 'Greta', LastName: 'Sims', Prefix: 'Ms.', Position: 'HR Manager', Picture: '../../../../images/employees/04.png', BirthDate: '1977/11/22', HireDate: '1998/04/23', Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.", Address: '1700 S Grandview Dr.', }, { ID: 5, FirstName: 'Brett', LastName: 'Wade', Prefix: 'Mr.', Position: 'IT Manager', Picture: '../../../../images/employees/05.png', BirthDate: '1968/12/01', HireDate: '2009/03/06', Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).', Address: '1120 Old Mill Rd.', }, { ID: 6, FirstName: 'Sandra', LastName: 'Johnson', Prefix: 'Mrs.', Position: 'Controller', Picture: '../../../../images/employees/06.png', BirthDate: '1974/11/15', HireDate: '2005/05/11', Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.", Address: '4600 N Virginia Rd.', }, { ID: 7, FirstName: 'Kevin', LastName: 'Carter', Prefix: 'Mr.', Position: 'Shipping Manager', Picture: '../../../../images/employees/07.png', BirthDate: '1978/01/09', HireDate: '2009/08/11', Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.', Address: '424 N Main St.', }, { ID: 8, FirstName: 'Cynthia', LastName: 'Stanwick', Prefix: 'Ms.', Position: 'HR Assistant', Picture: '../../../../images/employees/08.png', BirthDate: '1985/06/05', HireDate: '2008/03/24', Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!', Address: '2211 Bonita Dr.', }, { ID: 9, FirstName: 'Kent', LastName: 'Samuelson', Prefix: 'Dr.', Position: 'Ombudsman', Picture: '../../../../images/employees/02.png', BirthDate: '1972/09/11', HireDate: '2009/04/22', Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.', Address: '12100 Mora Dr', }];

import React from 'react';
import DataGrid, { Column } from 'devextreme-react/data-grid';
import DataRow from './DataRow.js';
import service from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.employees = service.getEmployees();
}
render() {
return (
<DataGrid id="gridContainer"
dataSource={this.employees}
keyExpr="ID"
columnAutoWidth={true}
showBorders={true}
rowAlternationEnabled={true}
hoverStateEnabled={true}
dataRowRender={DataRow}>
<Column caption="Photo" width={100} allowFiltering={false} allowSorting={false} />
<Column dataField="Prefix" width={70} caption="Title" />
<Column dataField="FirstName" />
<Column dataField="LastName" />
<Column dataField="Position" />
<Column dataField="BirthDate" dataType="date" />
<Column dataField="HireDate" dataType="date" />
</DataGrid>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer {
height: 450px;
}
.dx-row img {
height: 100px;
}
#gridContainer tr.main-row td:not(:first-child) {
height: 21px;
}
#gridContainer tr.notes-row {
white-space: normal;
vertical-align: top;
}
#gridContainer tr.notes-row td {
height: 70px;
color: #999;
}
.dark #gridContainer tr.notes-row td {
color: #777;
}
#gridContainer tbody.dx-state-hover {
background-color: #ebebeb;
}
.dark #gridContainer tbody.dx-state-hover {
background-color: #484848;
}
#gridContainer tbody.dx-state-hover tr.main-row td {
color: #000;
}
.dark #gridContainer tbody.dx-state-hover tr.main-row td {
color: #ccc;
}
#gridContainer tbody.dx-state-hover tr.notes-row td {
color: #888;
}
import React from 'react';
const formatDate = new Intl.DateTimeFormat('en-US').format;
export default function DataRow(rowInfo) {
return (
<React.Fragment>
<tr className="main-row">
<td rowSpan="2"><img src={rowInfo.data.Picture} /></td>
<td>{rowInfo.data.Prefix}</td>
<td>{rowInfo.data.FirstName}</td>
<td>{rowInfo.data.LastName}</td>
<td>{rowInfo.data.Position}</td>
<td>{formatDate(new Date(rowInfo.data.BirthDate))}</td>
<td>{formatDate(new Date(rowInfo.data.HireDate))}</td>
</tr>
<tr className="notes-row">
<td colSpan="6"><div>{rowInfo.data.Notes}</div></td>
</tr>
</React.Fragment>
);
}
const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
Picture: '../../../../images/employees/01.png',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
Picture: '../../../../images/employees/09.png',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
Picture: '../../../../images/employees/03.png',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
Picture: '../../../../images/employees/04.png',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
Picture: '../../../../images/employees/05.png',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
}];
export default {
getEmployees() {
return employees;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'globalize': 'npm:globalize@1.7.0/dist/globalize',
'json': 'npm:systemjs-plugin-json@0.3.0/json.js',
'cldr': 'npm:cldrjs@0.5.5/dist/cldr',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.42/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'globalize': {
main: '../globalize.js',
defaultExtension: 'js',
},
'cldr': {
main: '../cldr.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div>
<dx-data-grid
id="gridContainer"
:data-source="employees"
:column-auto-width="true"
:show-borders="true"
row-template="dataRowTemplate"
>
<dx-column
:width="100"
:allow-filtering="false"
:allow-sorting="false"
caption="Photo"
/>
<dx-column
:width="70"
data-field="Prefix"
caption="Title"
/>
<dx-column data-field="FirstName"/>
<dx-column data-field="LastName"/>
<dx-column data-field="Position"/>
<dx-column
data-field="BirthDate"
data-type="date"
/>
<dx-column
data-field="HireDate"
data-type="date"
/>
<template #dataRowTemplate="{ data: rowInfo }">
<tbody
:class="{'dx-row-alt': rowInfo.rowIndex % 2}"
class="employee dx-row"
>
<tr class="main-row">
<td rowspan="2"><img :src="rowInfo.data.Picture"></td>
<td>{{ rowInfo.data.Prefix }}</td>
<td>{{ rowInfo.data.FirstName }}</td>
<td>{{ rowInfo.data.LastName }}</td>
<td>{{ rowInfo.data.Position }}</td>
<td>{{ rowInfo.data.BirthDate | formatDate("yyyy/MM/dd") }}</td>
<td>{{ rowInfo.data.HireDate | formatDate("yyyy/MM/dd") }}</td>
</tr>
<tr class="notes-row">
<td colspan="6"><div>{{ rowInfo.data.Notes }}</div></td>
</tr>
</tbody>
</template>
</dx-data-grid>
</div>
</template>
<script>
import {
DxDataGrid,
DxColumn
} from 'devextreme-vue/data-grid';
import Globalize from 'globalize';
import 'devextreme/localization/globalize/date';
import service from './data.js';
export default {
components: {
DxDataGrid,
DxColumn
},
filters: {
formatDate(value, format) {
return Globalize.formatDate(new Date(value), { raw: format });
}
},
data() {
return {
employees: service.getEmployees()
};
},
};
</script>
<style scoped>
#gridContainer {
height: 450px;
}
.dx-row img {
height: 100px;
}
#gridContainer tr.main-row td:not(:first-child) {
height: 21px;
}
#gridContainer tr.notes-row {
white-space: normal;
vertical-align: top;
}
#gridContainer tr.notes-row td {
height: 70px;
color: #999;
}
.dark #gridContainer tr.notes-row td {
color: #777;
}
#gridContainer tbody.employee:hover {
background-color: #EBEBEB;
}
.dark #gridContainer tbody.employee:hover {
background-color: #484848;
}
#gridContainer tbody.employee:hover tr.main-row td {
color: #000;
}
.dark #gridContainer tbody.employee:hover tr.main-row td {
color: #CCC;
}
#gridContainer tbody.employee:hover tr.notes-row td {
color: #888;
}
</style>
import Vue from 'vue';
import App from './App.vue';
new Vue({
el: '#app',
components: { App },
template: '<App/>'
});
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
let employees = [{
'ID': 1,
'FirstName': 'John',
'LastName': 'Heart',
'Prefix': 'Mr.',
'Position': 'CEO',
'Picture': '../../../../images/employees/01.png',
'BirthDate': '1964/03/16',
'HireDate': '1995/01/15',
'Notes': 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
'Address': '351 S Hill St.'
}, {
'ID': 2,
'FirstName': 'Olivia',
'LastName': 'Peyton',
'Prefix': 'Mrs.',
'Position': 'Sales Assistant',
'Picture': '../../../../images/employees/09.png',
'BirthDate': '1981/06/03',
'HireDate': '2012/05/14',
'Notes': 'Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
'Address': '807 W Paseo Del Mar'
}, {
'ID': 3,
'FirstName': 'Robert',
'LastName': 'Reagan',
'Prefix': 'Mr.',
'Position': 'CMO',
'Picture': '../../../../images/employees/03.png',
'BirthDate': '1974/09/07',
'HireDate': '2002/11/08',
'Notes': 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
'Address': '4 Westmoreland Pl.'
}, {
'ID': 4,
'FirstName': 'Greta',
'LastName': 'Sims',
'Prefix': 'Ms.',
'Position': 'HR Manager',
'Picture': '../../../../images/employees/04.png',
'BirthDate': '1977/11/22',
'HireDate': '1998/04/23',
'Notes': "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
'Address': '1700 S Grandview Dr.'
}, {
'ID': 5,
'FirstName': 'Brett',
'LastName': 'Wade',
'Prefix': 'Mr.',
'Position': 'IT Manager',
'Picture': '../../../../images/employees/05.png',
'BirthDate': '1968/12/01',
'HireDate': '2009/03/06',
'Notes': 'Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
'Address': '1120 Old Mill Rd.'
}, {
'ID': 6,
'FirstName': 'Sandra',
'LastName': 'Johnson',
'Prefix': 'Mrs.',
'Position': 'Controller',
'Picture': '../../../../images/employees/06.png',
'BirthDate': '1974/11/15',
'HireDate': '2005/05/11',
'Notes': "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.",
'Address': '4600 N Virginia Rd.'
}, {
'ID': 7,
'FirstName': 'Kevin',
'LastName': 'Carter',
'Prefix': 'Mr.',
'Position': 'Shipping Manager',
'Picture': '../../../../images/employees/07.png',
'BirthDate': '1978/01/09',
'HireDate': '2009/08/11',
'Notes': 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.',
'Address': '424 N Main St.'
}, {
'ID': 8,
'FirstName': 'Cynthia',
'LastName': 'Stanwick',
'Prefix': 'Ms.',
'Position': 'HR Assistant',
'Picture': '../../../../images/employees/08.png',
'BirthDate': '1985/06/05',
'HireDate': '2008/03/24',
'Notes': 'Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!',
'Address': '2211 Bonita Dr.'
}, {
'ID': 9,
'FirstName': 'Kent',
'LastName': 'Samuelson',
'Prefix': 'Dr.',
'Position': 'Ombudsman',
'Picture': '../../../../images/employees/02.png',
'BirthDate': '1972/09/11',
'HireDate': '2009/04/22',
'Notes': 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
'Address': '12100 Mora Dr'
}];
export default {
getEmployees() {
return employees;
}
};
System.config({
transpiler: 'plugin-babel',
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
vue: 'npm:vue@2.6.3/dist/vue.esm.browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@latest/index.js',
'devextreme': 'npm:devextreme@19.2',
'devextreme-vue': 'npm:devextreme-vue@19.2',
jszip: 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.7/dist/quill.js',
'devexpress-diagram': 'npm:devexpress-diagram',
'devexpress-gantt': 'npm:devexpress-gantt',
'plugin-babel': 'npm:systemjs-plugin-babel@0/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0/systemjs-babel-browser.js',
'globalize': 'npm:globalize/dist/globalize',
'cldr': 'npm:cldrjs/dist/cldr',
'cldr-data': '../../../../js/cldr',
},
meta: {
'*.vue': { loader: 'vue-loader' }
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'globalize': {
main: '../globalize.js',
defaultExtension: 'js'
},
'cldr': {
main: '../cldr.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

<dx-data-grid id="gridContainer"
[dataSource]="employees"
[columnAutoWidth]="true"
[showBorders]="true"
rowTemplate="rowTemplateName">
<dxi-column caption="Photo" [width]="100" [allowFiltering]="false" [allowSorting]="false"></dxi-column>
<dxi-column dataField="Prefix" [width]="70" caption="Title"></dxi-column>
<dxi-column dataField="FirstName"></dxi-column>
<dxi-column dataField="LastName"></dxi-column>
<dxi-column dataField="Position"></dxi-column>
<dxi-column dataField="BirthDate" dataType="date"></dxi-column>
<dxi-column dataField="HireDate" dataType="date"></dxi-column>
<tbody class="employee dx-row" [ngClass]="{'dx-row-alt': employee.rowIndex % 2}" *dxTemplate="let employee of 'rowTemplateName'" >
<tr class="main-row">
<td rowspan="2"><img [src]="employee.data.Picture"/></td>
<td>{{employee.data.Prefix}}</td>
<td>{{employee.data.FirstName}}</td>
<td>{{employee.data.LastName}}</td>
<td>{{employee.data.Position}}</td>
<td>{{employee.data.BirthDate | date: "yyyy/MM/dd"}}</td>
<td>{{employee.data.HireDate | date: "yyyy/MM/dd"}}</td>
</tr>
<tr class="notes-row">
<td colspan="6"><div>{{employee.data.Notes}}</div></td>
</tr>
</tbody>
</dx-data-grid>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxDataGridModule, DxTemplateModule } from 'devextreme-angular';
import { Service, Employee } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
employees: Employee[];
constructor(service: Service) {
this.employees = service.getEmployees();
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule,
DxTemplateModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #gridContainer {
height: 450px;
}
::ng-deep .dx-row img {
height: 100px;
}
::ng-deep #gridContainer tr.main-row td:not(:first-child) {
height: 21px;
}
::ng-deep #gridContainer tr.notes-row {
white-space: normal;
vertical-align: top;
}
::ng-deep #gridContainer tr.notes-row td {
height: 70px;
color: #999;
}
::ng-deep .dark #gridContainer tr.notes-row td {
color: #777;
}
::ng-deep #gridContainer tbody.employee:hover {
background-color: #EBEBEB;
}
::ng-deep .dark #gridContainer tbody.employee:hover {
background-color: #484848;
}
::ng-deep #gridContainer tbody.employee:hover tr.main-row td {
color: #000;
}
::ng-deep .dark #gridContainer tbody.employee:hover tr.main-row td {
color: #CCC;
}
::ng-deep #gridContainer tbody.employee:hover tr.notes-row td {
color: #888;
}
import { Injectable } from '@angular/core';
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
Picture: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
}
let employees: Employee[] = [{
"ID": 1,
"FirstName": "John",
"LastName": "Heart",
"Prefix": "Mr.",
"Position": "CEO",
"Picture": "../../../../images/employees/01.png",
"BirthDate": "1964/03/16",
"HireDate": "1995/01/15",
"Notes": "John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003. When not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.",
"Address": "351 S Hill St."
}, {
"ID": 2,
"FirstName": "Olivia",
"LastName": "Peyton",
"Prefix": "Mrs.",
"Position": "Sales Assistant",
"Picture": "../../../../images/employees/09.png",
"BirthDate": "1981/06/03",
"HireDate": "2012/05/14",
"Notes": "Olivia loves to sell. She has been selling DevAV products since 2012. Olivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.",
"Address": "807 W Paseo Del Mar"
}, {
"ID": 3,
"FirstName": "Robert",
"LastName": "Reagan",
"Prefix": "Mr.",
"Position": "CMO",
"Picture": "../../../../images/employees/03.png",
"BirthDate": "1974/09/07",
"HireDate": "2002/11/08",
"Notes": "Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team. Robert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.",
"Address": "4 Westmoreland Pl."
}, {
"ID": 4,
"FirstName": "Greta",
"LastName": "Sims",
"Prefix": "Ms.",
"Position": "HR Manager",
"Picture": "../../../../images/employees/04.png",
"BirthDate": "1977/11/22",
"HireDate": "1998/04/23",
"Notes": "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp. Greta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
"Address": "1700 S Grandview Dr."
}, {
"ID": 5,
"FirstName": "Brett",
"LastName": "Wade",
"Prefix": "Mr.",
"Position": "IT Manager",
"Picture": "../../../../images/employees/05.png",
"BirthDate": "1968/12/01",
"HireDate": "2009/03/06",
"Notes": "Brett came to DevAv from Microsoft and has led our IT department since 2012. When he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).",
"Address": "1120 Old Mill Rd."
}, {
"ID": 6,
"FirstName": "Sandra",
"LastName": "Johnson",
"Prefix": "Mrs.",
"Position": "Controller",
"Picture": "../../../../images/employees/06.png",
"BirthDate": "1974/11/15",
"HireDate": "2005/05/11",
"Notes": "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi. Sandra has 2 daughters both of whom are accomplished gymnasts.",
"Address": "4600 N Virginia Rd."
}, {
"ID": 7,
"FirstName": "Kevin",
"LastName": "Carter",
"Prefix": "Mr.",
"Position": "Shipping Manager",
"Picture": "../../../../images/employees/07.png",
"BirthDate": "1978/01/09",
"HireDate": "2009/08/11",
"Notes": "Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months. When not in the office, he is usually on the basketball court playing pick-up games.",
"Address": "424 N Main St."
}, {
"ID": 8,
"FirstName": "Cynthia",
"LastName": "Stanwick",
"Prefix": "Ms.",
"Position": "HR Assistant",
"Picture": "../../../../images/employees/08.png",
"BirthDate": "1985/06/05",
"HireDate": "2008/03/24",
"Notes": "Cindy joined us in 2008 and has been in the HR department for 2 years. She was recently awarded employee of the month. Way to go Cindy!",
"Address": "2211 Bonita Dr."
}, {
"ID": 9,
"FirstName": "Kent",
"LastName": "Samuelson",
"Prefix": "Dr.",
"Position": "Ombudsman",
"Picture": "../../../../images/employees/02.png",
"BirthDate": "1972/09/11",
"HireDate": "2009/04/22",
"Notes": "As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.",
"Address": "12100 Mora Dr"
}];
@Injectable()
export class Service {
getEmployees() {
return employees;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "commonjs",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.4.5/lib/typescript.js',
'@angular/core': 'npm:@angular/core@8.0.0/bundles/core.umd.js',
'@angular/common': 'npm:@angular/common@8.0.0/bundles/common.umd.js',
'@angular/compiler': 'npm:@angular/compiler@8.0.0/bundles/compiler.umd.js',
'@angular/platform-browser': 'npm:@angular/platform-browser@8.0.0/bundles/platform-browser.umd.js',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@8.0.0/bundles/platform-browser-dynamic.umd.js',
'@angular/router': 'npm:@angular/router@8.0.0/bundles/router.umd.js',
'@angular/forms': 'npm:@angular/forms@8.0.0/bundles/forms.umd.js',
'@angular/common/http': 'npm:@angular/common@8.0.0/bundles/common-http.umd.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@6.3.3',
'rxjs/operators': 'npm:rxjs@6.3.3/operators',
'devextreme': 'npm:devextreme@19.2',
'jszip': 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.7/dist/quill.js',
'devexpress-diagram': 'npm:devexpress-diagram',
'devexpress-gantt': 'npm:devexpress-gantt',
'devextreme-angular': 'npm:devextreme-angular@19.2'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'rxjs': { main: 'index.js', defaultExtension: 'js' },
'rxjs/operators': { main: 'index.js', defaultExtension: 'js' },
'devextreme-angular': {
main: 'index.js',
defaultExtension: 'js'
}
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.6.25/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>